#!/bin/bash

# Post the video card
/usr/sbin/vm86_video_post

# Attempt to restore some video card state
/usr/sbin/vbestate restore <$VBESTATE
rm $VBESTATE

# Load any drivers that we removed
for x in $MODULES; do
    modprobe $x;
done

# Get PCMCIA cards back
cardctl insert

# Bring up the interfaces (this should probably be left up to some policy
# manager, but at the moment we just bring back whatever we ifdowned)
#for x in $INTERFACES; do
#    ifup $x;
#done

# Actually, we don't for the moment - we end up waiting for things to time out
# because multiple ifups want to write to the state file and it's locked. We
# need a better way of doing this - for now just bring back up whatever is
# flagged as auto

ifup -a

# Reset the time
hwclock --hctosys

# And make sure that the screen is on
/usr/sbin/dpms on

# Some hardware needs another X/console switch in order to bring stuff back
chvt $CONSOLE;
chvt 12;
chvt $CONSOLE;

# Some hardware gets unhappy about button events unless we do this
rmmod button
modprobe button

# Other half of the hideous hack
/etc/init.d/acpid start >/dev/null 2>&1
